//Gestion de module suiveur de ligne QTR-3RC 3 capteurs
//Utilisation avec carte arduino
//cablage :bornes arduino { 5, 6, 7}  vers 1 2 3 de QTR_3RC
//Utilisation des moteurs : moteur A = moteur droit

/************Version lente****************
        ça marche Rayon virage > 200mm
        essai avec extreme virage => ok
 ***************************************/

/*
   extreme virage :
   Si les trois capteurs < 100 et position =2000 ==> robot sortie de ligne à droite
   Si les trois capteurs < 100 et position =0 ==> robot sortie de ligne à gauche

*/

#define dir_A 12
#define vitesseA 3
#define dir_B 13
#define vitesseB 11

#include <QTRSensors.h>

QTRSensors qtr;

//const uint8_t SensorCount = 8;
const uint8_t SensorCount = 3;
uint16_t sensorValues[SensorCount];

void setup()
{
  // configure the sensors
  qtr.setTypeRC();
  //  qtr.setSensorPins((const uint8_t[]){3, 4, 5, 6, 7, 8, 9, 10}, SensorCount);
  qtr.setSensorPins((const uint8_t[]) {   5, 6, 7  }, SensorCount);
  //emitterPin n'existe que sur les détecteurs de lignes QTR 8A et 8RC QTR
  //qtr.setEmitterPin(2);

  delay(500);
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH); // turn on Arduino's LED to indicate we are in calibration mode

  // 2.5 ms RC read timeout (default) * 10 reads per calibrate() call
  // = ~25 ms per calibrate() call.
  // Call calibrate() 400 times to make calibration take about 10 seconds.
  for (uint16_t i = 0; i < 400; i++)
  {
    qtr.calibrate();
  }
  digitalWrite(LED_BUILTIN, LOW); // turn off Arduino's LED to indicate we are through with calibration

  // print the calibration minimum values measured when emitters were on
  Serial.begin(9600);
  for (uint8_t i = 0; i < SensorCount; i++)
  {
    Serial.print(qtr.calibrationOn.minimum[i]);
    Serial.print(' ');
  }
  Serial.println();

  // print the calibration maximum values measured when emitters were on
  for (uint8_t i = 0; i < SensorCount; i++)
  {
    Serial.print(qtr.calibrationOn.maximum[i]);
    Serial.print(' ');
  }
  Serial.println();
  Serial.println();
  delay(1000);
}

void loop()
{
  // read calibrated sensor values and obtain a measure of the line position
  // from 0 to 5000 (for a white line, use readLineWhite() instead)
  uint16_t position = qtr.readLineBlack(sensorValues);

  // print the sensor values as numbers from 0 to 1000, where 0 means maximum
  // reflectance and 1000 means minimum reflectance, followed by the line
  // position
  /* for (uint8_t i = 0; i < SensorCount; i++)
    {
     Serial.print(sensorValues[i]);
     Serial.print('\t');
    }
    Serial.println(position);*/

  //Faire tourner les moteurs A et B pour marche AV
  //Ecrire : digitalWrite(dir_A, HIGH ou LOW);
  digitalWrite(dir_A, LOW);
  digitalWrite(dir_B, LOW);

  if (sensorValues[0]< 100 && sensorValues[1]< 100 && sensorValues[2]< 100 && position < 100) {
    analogWrite(vitesseA, 0);
    analogWrite(vitesseB, 0);
    delay(100);
    analogWrite(vitesseB, 90);
    delay(50);
  }
  else if (sensorValues[0]< 100 && sensorValues[1]< 100 && sensorValues[2]< 100 && position ==2000) {
    analogWrite(vitesseA, 0);
    analogWrite(vitesseB, 0);
    delay(100);
    analogWrite(vitesseA, 90);
    delay(50);
  }
  else if (position > 1750) {
    // Serial.println("Le robot est très à droite ");
    //Faire tourner les moteurs A et B pour marche AV
    //Ecrire : digitalWrite(dir_A, HIGH ou LOW);

    //Fixer la vitesse des moteurs A et B pour tourner rapidement à gauche
    //Ecrire : analogWrite(vitesseA, un nombre de 0 à 255);
    analogWrite(vitesseA, 70);
    analogWrite(vitesseB, 30);
  } else if ( position <= 1750 && position > 1000) {
    //Serial.println("Le robot est un peu à droite ");
    //Faire tourner les moteurs A et B pour marche AV
    //Ecrire : digitalWrite(dir_A, HIGH ou LOW);
    //digitalWrite(dir_A, LOW);
    //digitalWrite(dir_B, LOW);
    //Fixer la vitesse des moteurs A et B pour tourner un peu à gauche
    //Ecrire : analogWrite(vitesseA, un nombre de 0 à 255);
    analogWrite(vitesseA, 70);
    analogWrite(vitesseB, 60);
  } else if ( position <= 1000 && position > 250) {
    //Serial.println("Le robot est un peu à gauche ");
    //Faire tourner les moteurs A et B pour marche AV
    //Ecrire : digitalWrite(dir_A, HIGH ou LOW);
    //digitalWrite(dir_A, LOW);
    //digitalWrite(dir_B, LOW);
    //Fixer la vitesse des moteurs A et B pour tourner un peu à droite
    //Ecrire : analogWrite(vitesseA, un nombre de 0 à 255);
    analogWrite(vitesseA, 60);
    analogWrite(vitesseB, 70);
  } else {
    //Serial.println("Le robot est très à gauche ");
    //Faire tourner les moteurs A et B pour marche AV
    //Ecrire : digitalWrite(dir_A, HIGH ou LOW);
    //digitalWrite(dir_A, LOW);
    //digitalWrite(dir_B, LOW);
    //Fixer la vitesse des moteurs A et B pour tourner rapidement à droite
    //Ecrire : analogWrite(vitesseA, un nombre de 0 à 255);
    analogWrite(vitesseA, 30);
    analogWrite(vitesseB, 70);
  }
  //  delay(250);
}
